// LinkStatic.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "LinkStatic.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define	OUT_COLOR	RGB(0, 0, 255)		// ʏ̃NF
#define	OVER_COLOR	RGB(255, 128, 0)	// NɃ}EX̐F

/////////////////////////////////////////////////////////////////////////////
// CLinkStatic

// ݒ
CLinkStatic::CLinkStatic()
{
	m_bClick = FALSE;
	
	// w̃J[\ǂݍ
	OSVERSIONINFO in;ZeroMemory(&in,sizeof(in));in.dwOSVersionInfoSize=sizeof(OSVERSIONINFO);GetVersionEx(&in);
	TCHAR lpWinDir[MAX_PATH];
	::GetWindowsDirectory(lpWinDir, MAX_PATH - 13);
	if(in.dwMajorVersion<=5){
		_tcscat(lpWinDir, _T("\\winhlp32.exe"));
		HINSTANCE hInstHelp = ::LoadLibrary(lpWinDir);
		if(hInstHelp)
		{
			m_hCursor = CopyCursor(::LoadCursor(hInstHelp, MAKEINTRESOURCE(106)));
			::FreeLibrary(hInstHelp);
		}
		else
			m_hCursor = ::LoadCursor(NULL, IDC_ARROW);
	}else{
		TCHAR tmp[1024];
		DWORD r=ExpandEnvironmentStrings( _T("%windir%") , tmp,1024);
		CString s;s=tmp;s+="\\cursors\\aero_link.cur";
		if(r!=0)
			m_hCursor = CopyCursor(::LoadCursorFromFile(s));
		else
			m_hCursor = ::LoadCursor(NULL, IDC_ARROW);
	}
	m_text = OUT_COLOR;
	m_brush.CreateSolidBrush(::GetSysColor(COLOR_3DFACE));
}

CLinkStatic::~CLinkStatic()
{
}


BEGIN_MESSAGE_MAP(CLinkStatic, CStatic)
	//{{AFX_MSG_MAP(CLinkStatic)
	ON_WM_CTLCOLOR_REFLECT()
	ON_WM_SETCURSOR()
	ON_WM_MOUSEMOVE()
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONUP()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CLinkStatic bZ[W nh

// N̐F̕ύX
HBRUSH CLinkStatic::CtlColor(CDC* pDC, UINT nCtlColor) 
{
	// ŏɌĂ΂ꂽtHg̐ݒij
	if(!m_font.m_hObject)
	{
		LOGFONT lf;
		GetFont()->GetLogFont(&lf);
		lf.lfUnderline = TRUE;
		m_font.CreateFontIndirect(&lf);
		SetFont(&m_font, FALSE);
		Invalidate();
	}

	// Fݒ
	pDC->SetTextColor(m_text);
	pDC->SetBkColor(::GetSysColor(COLOR_3DFACE));
	return m_brush;
}

// }EXN̏ɂJ[\ύX
BOOL CLinkStatic::OnSetCursor(CWnd* pWnd, UINT nHitTest, UINT message) 
{
	::SetCursor(m_hCursor);
	return TRUE;
}

// J[\Nɂ̐F̕ύX
void CLinkStatic::OnMouseMove(UINT nFlags, CPoint point) 
{
	if(GetCapture() == NULL)
	{
		m_text = OVER_COLOR;
		Invalidate();
		SetCapture();
	}

	RECT rect;
	GetClientRect(&rect);
	if(!PtInRect(&rect, point) && !m_bClick)
	{
		ReSetColor();
		::ReleaseCapture();
	}
	CStatic::OnMouseMove(nFlags, point);
}

// NɃWv
void CLinkStatic::OnLButtonDown(UINT nFlags, CPoint point) 
{
	// NNbNƂtÕZbg
	m_bClick = TRUE;
	CStatic::OnLButtonDown(nFlags, point);
}
void CLinkStatic::OnLButtonUp(UINT nFlags, CPoint point) 
{
	RECT rect;

	// NbNtOON̎
	if(m_bClick)
	{
		::ReleaseCapture();
		GetClientRect(&rect);

		// NŃ}EXꂽ
		if(PtInRect(&rect, point))
		{
			// LvVURL擾
			CString strJump;
			GetWindowText(strJump);

			// LvV":"̕΃[AhXƂ݂Ȃ
			if(strJump.Find(':') == -1)
				strJump = _T("mailto:") + strJump;

			// uEUi̓[[jNWv
//			::ShellExecute(NULL, _T("open"), strJump, NULL, NULL, SW_SHOWNORMAL);
			::ShellExecute(NULL, NULL , strJump, NULL, NULL, SW_SHOWNORMAL);

			// uEUNɃ}EXNOɏoƂׂ̈̏
			GetWindowRect(&rect);
			::GetCursorPos(&point);
			if(!PtInRect(&rect, point))
				ReSetColor();
		}
		else
			ReSetColor();

		m_bClick = FALSE;
	}
	CStatic::OnLButtonUp(nFlags, point);
}

// Fɖ߂čĕ\
void CLinkStatic::ReSetColor()
{
	m_text = OUT_COLOR;
	Invalidate();
}